#include <bits/stdc++.h>
using namespace std;

const long long INF = 1LL << 40;

int main() {
    int N, T;
    long long K;
    cin >> N >> K >> T;
    vector<long long> A(N);
    for (auto &a : A) cin >> a;

    for (int i=0; i<N; ++i) A[i] -= K*i;

    vector<long long> best(1, -INF);
    for (long long a : A) {
        int lo = 0, hi = best.size();
        while (hi - lo > 1) {
            int med = (lo + hi) / 2;
            if (best[med] >= a) lo = med; else hi = med;
        }
        best.push_back(INF);
        best[hi] = a;
        if (best.back() == INF) best.pop_back();
    }
    int longest = best.size() - 1;
    cout << (N - longest) << endl;
}
