#include <bits/stdc++.h>
using namespace std;

const long long INF = 1LL << 40;
const long long MAX_ALLOWED = 1000000000;

int main() {
    int N, T;
    long long K;
    cin >> N >> K >> T;
    vector<long long> A(N);
    for (auto &a : A) cin >> a;

    for (int i=0; i<N; ++i) A[i] -= K*i;

    vector<long long> best(1, -INF);
    vector<int> best_index(1, -1), prev(N, -1);

    for (int i=0; i<N; ++i) {
        int lo = 0, hi = best.size();
        while (hi - lo > 1) {
            int med = (lo + hi) / 2;
            if (best[med] >= A[i]) lo = med; else hi = med;
        }
        best.push_back(INF); best_index.push_back(-1);
        prev[i] = best_index[hi-1];
        best[hi] = A[i];
        best_index[hi] = i;
        if (best.back() == INF) { best.pop_back(); best_index.pop_back(); }
    }
    int longest = best.size() - 1;
    cout << (N - longest) << endl;
    if (T == 1) return 0;
    
    for (int i=0; i<N; ++i) A[i] += K*i;

    vector<bool> keep(N, false);
    int where = best_index.back();
    while (true) {
        if (where == -1) break;
        keep[where] = true;
        where = prev[where];
    }

    int start = 0;
    while (!keep[start]) ++start;
    for (int i=0; i<start; ++i) A[i] = A[start];
    for (int i=start; i<N; ++i) if (!keep[i]) A[i] = min( A[i-1]+K, MAX_ALLOWED );
    for (int i=0; i<N; ++i) cout << A[i] << (i+1==N ? "\n" : " ");
}
